function IRFs=GetIRFsCointegratedVECM(A0,BB,GG,LagOrder,N,Horizon,LRI,NumberOfShocks);
%
IRFs=zeros(Horizon+1,N,NumberOfShocks);
%
Shock=1;
while Shock<=NumberOfShocks
    XX=zeros(N,LagOrder+1+Horizon);
    YY=zeros(N,LagOrder+1+Horizon);
    tt=LagOrder+1;
    while tt<=LagOrder+1+Horizon
        if tt==LagOrder+1
            Shocks=zeros(N,1);
            Shocks(Shock)=1;
            XX(:,tt)=BB*vec(fliplr(XX(:,tt-LagOrder:tt-1)))+GG*YY(:,tt-1)+A0*Shocks;
        else
            XX(:,tt)=BB*vec(fliplr(XX(:,tt-LagOrder:tt-1)))+GG*YY(:,tt-1);
        end
        YY(:,tt)=YY(:,tt-1)+XX(:,tt);
        tt=tt+1;
    end
    YY=YY';
    YY=YY(LagOrder+1:LagOrder+1+Horizon,:);
    YY=YY*sign(LRI(Shock,Shock));
    IRFs(:,:,Shock)=YY;
    Shock=Shock+1;
end