function L=varplagselect(y,INT,P,CRIT,Horizon)
if nargin<5
    Horizon=1;
end
%
[T,N]=size(y);
%
% Selecting lag length:
for pp=1:P
    [B,VARB,U,V]=varp(y,pp,INT,Horizon);
    aic(pp,1)=log(det(V))+(2*pp*N^2)/T;
    sic(pp,1)=log(det(V))+(pp*N^2)*(log(T)/T);
    hq(pp,1)=log(det(V))+(pp*N^2)*(2*log(log(T))/T);
end
%
if CRIT=='AIC'
    L=(1:1:P)*(aic==min(aic));
elseif CRIT=='SIC'
    L=(1:1:P)*(sic==min(sic));
elseif CRIT=='HQQ'
    L=(1:1:P)*(hq==min(hq));
end