function [MAMatricesX,MAMatricesY]=GetMARepresentationCointegratedVECM(BB,GG,LagOrder,N,Horizon);
%
MAMatricesX=zeros(N,N,Horizon+1);
MAMatricesY=zeros(N,N,Horizon+1);
%
Shock=1;
while Shock<=N
    XX=zeros(N,LagOrder+1+Horizon);
    YY=zeros(N,LagOrder+1+Horizon);
    tt=LagOrder+1;
    while tt<=LagOrder+1+Horizon
        if tt==LagOrder+1
            Shocks=zeros(N,1);
            Shocks(Shock)=1;
            XX(:,tt)=BB*vec(fliplr(XX(:,tt-LagOrder:tt-1)))+GG*YY(:,tt-1)+Shocks;
            MAMatricesX(:,Shock,tt-LagOrder)=XX(:,tt);
        else
            XX(:,tt)=BB*vec(fliplr(XX(:,tt-LagOrder:tt-1)))+GG*YY(:,tt-1);
            MAMatricesX(:,Shock,tt-LagOrder)=XX(:,tt);
        end
        YY(:,tt)=YY(:,tt-1)+XX(:,tt);
        MAMatricesY(:,Shock,tt-LagOrder)=YY(:,tt);
        tt=tt+1;
    end
    Shock=Shock+1;
end


