function [VV,DD]=OrderedEig(X)
[V,D]=eig(X);
AbsEigenvalues=abs(diag(D));
OrderedAbsEigenvalues=flipud(sort(AbsEigenvalues));
Order=zeros(size(AbsEigenvalues));
N=length(Order);
for zz=1:N
   Order(zz)=maxindc(AbsEigenvalues==OrderedAbsEigenvalues(zz));
end
VV=zeros(size(V));
DD=zeros(size(D));
for zz=1:N
    DD(zz,zz)=D(Order(zz),Order(zz));
    VV(:,zz)=V(:,Order(zz));
end
